<template>
  <div class="WG_box">
    <div class="WG_title">网格管理</div>
    <div class="form_box">
      <div class="inp_box">
        <span>网格位置</span>
        <el-select v-model="data.SJvalue" class="m-2" size="large">
          <el-option
            v-for="(item, i) in optionsSJ"
            :key="i"
            :label="item.label"
            :value="item.value"
          />
        </el-select>
      </div>
      <div class="inp_box">
        <span>溯源距离</span>
        <el-select v-model="data.JLvalue" class="m-2" size="large">
          <el-option
            v-for="item in optionsJL"
            :key="item.value"
            :label="item.label"
            :value="item.value"
          />
        </el-select>
      </div>
      <div class="button_box">
        <el-button size="small" @click="selectList">确认</el-button>
      </div>
    </div>
    <el-table
      :data="data.tableData"
      style="width: 100%"
      height="88%"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" />
      <el-table-column prop="vocsName" label="名称" />
      <el-table-column prop="lon" label="经度" />
      <el-table-column prop="lat" label="纬度" />
      <el-table-column align="right">
        <template #header>
          <el-button link type="primary" size="small" @click="editName"
            >编辑名称</el-button
          >
        </template>
      </el-table-column>
    </el-table>
    <el-dialog
      v-model="data.dialogFormVisible"
      title="编辑选中名称"
      :append-to-body="true"
    >
      <el-form
        :model="form"
        label-position="top"
        ref="formRef"
        :rules="rules"
        size="large"
      >
        <el-form-item label="点位名称" prop="name">
          <el-input
            size="large"
            v-model="form.name"
            autocomplete="off"
            placeholder="请输入名称"
          />
        </el-form-item>
      </el-form>
      <template #footer>
        <span class="dialog-footer">
          <el-button @click="data.dialogFormVisible = false">关闭</el-button>
          <el-button type="primary" @click="addPoi(formRef)"> 修改 </el-button>
        </span>
      </template>
    </el-dialog>
  </div>
</template>

<script>
// import type { FormInstance, FormRules } from "element-plus";
import { reactive, onMounted, watch, ref } from 'vue';
import { FormInstance, ElMessage, ElMessageBox } from 'element-plus';
import { useStore } from 'vuex';
import {
  ysshSuYuanX00Controller,
  ysshSuYuanX00ControllerUpdate,
  locationControllerQ,
} from '@/api/api.js';
export default {
  //import引入的组件需要注入到对象中才能使用
  components: {},
  setup(props) {
    const formRef = ref < FormInstance > '';
    const store = useStore();
    let data = reactive({
      SJvalue: '',
      JLvalue: '100',
      tableData: [],
      dialogFormVisible: false,
      changelist: [],
      changeID: [],
    });
    const form = reactive({
      name: '',
    });
    const rules = ref({
      name: [
        {
          required: true,
          message: '请输入名称',
          trigger: 'blur',
        },
      ],
    });
    let optionsSJ = ref([
      // {
      //   value: "AI-01",
      //   label: "AI-01",
      // },
      // {
      //   value: "AI-02",
      //   label: "AI-02",
      // },
      // {
      //   value: "AI-03",
      //   label: "AI-03",
      // },
      // {
      //   value: "AI-04",
      //   label: "AI-04",
      // },
      // {
      //   value: "AI-05",
      //   label: "AI-05",
      // },
      // {
      //   value: "AI-06",
      //   label: "AI-06",
      // },
      // {
      //   value: "AI-07",
      //   label: "AI-07",
      // },
      // {
      //   value: "AI-08",
      //   label: "AI-08",
      // },
      // {
      //   value: "AI-09",
      //   label: "AI-09",
      // },
      // {
      //   value: "AI-10",
      //   label: "AI-10",
      // },
      // {
      //   value: "AI-11",
      //   label: "AI-11",
      // },
      // {
      //   value: "AI-12",
      //   label: "AI-12",
      // },
      // {
      //   value: "AI-13",
      //   label: "AI-13",
      // },
      // {
      //   value: "AI-14",
      //   label: "AI-14",
      // },
      // {
      //   value: "AI-15",
      //   label: "AI-15",
      // },
      // {
      //   value: "AI-16",
      //   label: "AI-16",
      // },
      // {
      //   value: "AI-17",
      //   label: "AI-17",
      // },
      // {
      //   value: "AI-18",
      //   label: "AI-18",
      // },
      // {
      //   value: "AI-19",
      //   label: "AI-19",
      // },
      // {
      //   value: "AI-20",
      //   label: "AI-20",
      // },
      // {
      //   value: "AI-21",
      //   label: "AI-21",
      // },
      // {
      //   value: "AI-22",
      //   label: "AI-22",
      // },
      // {
      //   value: "AI-23",
      //   label: "AI-23",
      // },
      // {
      //   value: "AI-24",
      //   label: "AI-24",
      // },
      // {
      //   value: "AI-25",
      //   label: "AI-25",
      // },
      // {
      //   value: "AI-26",
      //   label: "AI-26",
      // },
      // {
      //   value: "AI-27",
      //   label: "AI-27",
      // },
      // {
      //   value: "AI-28",
      //   label: "AI-28",
      // },
      // {
      //   value: "AI-29",
      //   label: "AI-29",
      // },
      // {
      //   value: "AI-30",
      //   label: "AI-30",
      // },
      // {
      //   value: "AI-31",
      //   label: "AI-31",
      // },
      // {
      //   value: "AI-32",
      //   label: "AI-32",
      // },
      // {
      //   value: "AI-33",
      //   label: "AI-33",
      // },
      // {
      //   value: "AI-34",
      //   label: "AI-34",
      // },
      // {
      //   value: "AI-35",
      //   label: "AI-35",
      // },
      // {
      //   value: "AI-36",
      //   label: "AI-36",
      // },
      // {
      //   value: "AI-37",
      //   label: "AI-37",
      // },
      // {
      //   value: "AI-38",
      //   label: "AI-38",
      // },
      // {
      //   value: "AI-39",
      //   label: "AI-39",
      // },
      // {
      //   value: "AI-40",
      //   label: "AI-40",
      // },
      // {
      //   value: "AI-41",
      //   label: "AI-41",
      // },
      // {
      //   value: "AI-42",
      //   label: "AI-42",
      // },
      // {
      //   value: "AI-43",
      //   label: "AI-43",
      // },
      // {
      //   value: "AI-44",
      //   label: "AI-44",
      // },
      // {
      //   value: "AI-45",
      //   label: "AI-45",
      // },
      // {
      //   value: "AI-46",
      //   label: "AI-46",
      // },
      // {
      //   value: "YF",
      //   label: "YF",
      // },
    ]);
    const optionsJL = reactive([
      {
        value: '100',
        label: '100m',
      },
      {
        value: '200',
        label: '200m',
      },
      // {
      //   value: "300",
      //   label: "300m",
      // },
      // {
      //   value: "500",
      //   label: "500m",
      // },
    ]);
    const selectList = async () => {
      let date = new Date();
      let year = date.getFullYear();
      let month = (date.getMonth() + 1) < 10 ?  '0'+(date.getMonth() + 1):(date.getMonth() + 1);
      let day = date.getDate() < 10 ? '0'+date.getDate() : date.getDate();
      let hours = date.getHours() < 10 ? '0'+date.getHours() : date.getHours();
      let timeStr = year+"-"+month+"-"+day+" "+hours+":00:00";
      const dt = await ysshSuYuanX00Controller(
        { name: data.SJvalue,date:timeStr},
        data.JLvalue
      );
      let arr = [];
      // data.tableData = dt.result.data;
      let tempList = dt.result.data;
      if (localStorage.getItem("gridlist")){
        let list = JSON.parse(localStorage.getItem("gridlist"));
        for (const item of tempList) {
          for (const element of list) {
            if (element.id == item.id){
              item.vocsName = element.name;
            }
          }
        }
      }
      data.tableData = tempList;
      // sgworld.Navigate.flyToPosition(dt.result[30].lon, dt.result[30].lat, 400);
      sgworld.Navigate.flyToPosition(
        dt.result.data[30].lon,
        dt.result.data[30].lat - 0.002,
        400,
        {
          heading: -90,
          pitch: -30,
          roll: 0,
        }
      );
      dt.result.data.forEach((e) => {
        arr.push({
          id: e.id,
          name: e.vocsName,
          vocs: e.vocsValue,
          tm: 2,
          lon: e.lon,
          lat: e.lat,
          high: 300,
          vc: 'E9FF00FF',
          nc: 'FFFFFFFF',
          bool: false,
        });
      });
      sgworld.Core.postMessage({
        type: 'newgezi',
        geziarr: arr,
      });
    };
    //网格名称选择框
    const getWGname = async () => {
      const dt = await locationControllerQ({ type: '监控点' });
      const dt1 = await locationControllerQ({ type: '超级站' });
      let arr = [...dt.result, ...dt1.result];

      arr.forEach((e) => {
        optionsSJ.value.push({ value: e.name, label: e.name });
      });

      data.optionisshow = true;
    };
    const addPoi = (res) => {
      res.validate(async (valid, fields) => {
        if (valid) {
          ElMessageBox.confirm('确定是否修改', 'Warning', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning',
          })
            .then(async () => {
              let obj = {
                id: data.changeID[0],
                name: form.name,
              };
              if (localStorage.getItem("gridlist")){
                let list = JSON.parse(localStorage.getItem("gridlist"));
                for (const item of list) {
                  if (item.id == obj.id){
                    item.name = obj.name;
                  }else {
                    list.push(obj)
                  }
                }
                localStorage.setItem("gridlist",JSON.stringify(list));
              }else {
                let gridlist = [obj];
                localStorage.setItem("gridlist",JSON.stringify(gridlist));
              }
              // let obj = {
              //   ids: data.changeID,
              //   newName: form.name,
              // };
              // const dt = await ysshSuYuanX00ControllerUpdate(obj, 100);
              // const dt1 = await ysshSuYuanX00ControllerUpdate(obj, 200);
              // const dt2 = await ysshSuYuanX00ControllerUpdate(obj, 300);
              // const dt3 = await ysshSuYuanX00ControllerUpdate(obj, 500);
              // if (dt.code != 200) {
              //   return ElMessage.error('修改失败');
              // }
              ElMessage({
                message: '修改成功',
                type: 'success',
              });
              selectList();
              data.dialogFormVisible = false;
            })
            .catch(() => {});
        }
      });
    };
    const handleSelectionChange = (val) => {
      data.changeID = [];
      data.changelist = val;
      val.forEach((element) => {
        data.changeID.push(element.id);
      });
    };
    const editName = () => {
      if (data.changelist.length > 0) {
        data.dialogFormVisible = true;
      } else {
        return ElMessage.error('请选择需要修改的网格');
      }
    };
    getWGname();
    onMounted(() => {});
    return {
      data,
      selectList,
      optionsSJ,
      optionsJL,
      form,
      addPoi,
      rules,
      formRef,
      handleSelectionChange,
      editName,
    };
  },
};
</script>
<style lang="less" scoped>
//@import url(); 引入公共css类
.WG_box {
  position: absolute;
  right: 70px;
  top: 490px;
  width: 964px;
  height: 591px;
  padding: 50px;
  box-sizing: border-box;
  background: url('../assets/img/zbg.png') no-repeat center;
  background-size: 100% 100%;
  .WG_title {
    font-size: 30px;
    font-weight: bold;
    color: #ffffff;
    padding-bottom: 10px;
  }
  .form_box {
    display: flex;
    justify-content: space-around;
    align-items: center;
    .inp_box {
      span {
        font-size: 24px;
        font-weight: 400;
        color: #ffffff;
        padding-right: 10px;
      }
      .el-select {
        width: 180px;
      }
      .el-select /deep/ .el-input__wrapper {
        background: rgba(0, 0, 0, 0.2);
        border: 2px solid #2e58cc;
        border-radius: 10px;
        color: #ffffff;
        padding: 0;
        padding-left: 3px;
      }
      .el-select /deep/ .el-input__inner {
        color: #ffffff;
        font-size: 24px;
      }
    }
  }
  .el-table {
    // height: 370px;
    width: 100%;
    overflow: auto;
    background-color: transparent;
    font-size: 28px;
  }
  .el-table::before {
    height: 0;
  }
  .el-table /deep/ .el-tooltip {
    padding: 0;
  }
  .el-table /deep/ th,
  .el-table /deep/ tr {
    background-color: transparent;
    color: white;
  }
  .el-table /deep/ tr:hover > td {
    background-color: rgba(0, 0, 0, 1) !important;
  }
  /deep/ .el-table__body {
    width: 100% !important;
  }

  /deep/ .el-table__header {
    width: 100% !important;
  }
}
.el-button {
  background: rgba(0, 0, 0, 0.2);
  border: 2px solid #2e58cc;
  border-radius: 10px;
  color: #ffffff;
}
.el-form /deep/ .el-input__inner,
.el-form /deep/ .el-textarea__inner {
  //   background-color: rgba(134, 132, 132, 0.5);
  border-radius: 0;
  color: white;
}
.el-form /deep/ .el-input__wrapper {
  background-color: rgba(134, 132, 132, 0.5);
  border-radius: 0;
  color: white;
}
.el-form /deep/ .el-form-item__label {
  color: white;
}
</style>
<style>
.el-dialog {
  width: 600px !important;
  background-color: rgba(0, 20, 67, 0.6) !important;
}

.el-dialog__header span {
  font-size: 25px;
  color: #fff;
}
</style>
